# Copyright (C) 2012 Holger Hans Peter Freyther
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import dbus

sms = []

class SmsWatcher:
    def __init__(self, sms):
        self.sms = sms
        self.watched = {}
        self.sms.connect_to_signal("MessageAdded", self._msg_added)
        self.sms.connect_to_signal("MessageRemoved", self._msg_removed)

    def _msg_added(self, property, value):
        self.watched[property] = 1
        print "PROP: ", property
        print "VA:: ", value

    def _msg_removed(self, property):
        try:
            del self.watched[property]
        except KeyError:
            pass
        print "PROP: ", property

def get(bus, name):
    sms = dbus.Interface(
                    bus.get_object('org.ofono', name),
                    'org.ofono.MessageManager')
    return sms

def send_message(manager, number, text, delivery_report):
    manager.SetProperty('UseDeliveryReports', dbus.Boolean(int(delivery_report)))
    return manager.SendMessage(number, text)

def wait_for_sent(sms):
    pass

def get_messages(manager):
    messages = manager.GetMessages()
    print messages[0]
    print dir(messages[0])
